Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_prep.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_prep.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_prep.F90	(revision 15799)
@@ -1230,6 +1232,10 @@
       CALL obs_int_comm_2d( 2, 2, kprofno, kpi, kpj, igrdi, igrdj, plam, zglam )
       CALL obs_int_comm_2d( 2, 2, kprofno, kpi, kpj, igrdi, igrdj, pphi, zgphi )
+      CALL obs_int_comm_2d( 2, 2, kprofno, kpi, kpj, igrdi, igrdj, REAL(mbkt), zbathy )
+      ! Need to know the bathy depth for each observation for sco
       CALL obs_int_comm_3d( 2, 2, kprofno, kpi, kpj, kpk, igrdi, igrdj, gdepw_n(:,:,:), &
-        &                     zgdepw )
+        &                   zgdepw )
+      CALL obs_int_comm_3d( 2, 2, kprofno, kpi, kpj, kpk, igrdi, igrdj, gdept_n(:,:,:), &
+         &                  zgdept )
 
       DO jobs = 1, kprofno
@@ -1267,11 +1273,25 @@
          DO jobsp = kpstart(jobs), kpend(jobs)
 
+            ! Calculate max T and W depths of 2x2 grid
+            maxdept = zgdept(1,1,NINT(zbathy(1,1,jobs)),jobs)
+            maxdepw = zgdepw(1,1,NINT(zbathy(1,1,jobs))+1,jobs)
+            DO jj = 1, 2
+               DO ji = 1, 2
+                  IF ( zgdept(ji,jj,NINT(zbathy(ji,jj,jobs)),jobs) > maxdept ) THEN
+                     maxdept = zgdept(ji,jj,NINT(zbathy(ji,jj,jobs)),jobs)
+                  END IF
+                  IF ( zgdepw(ji,jj,NINT(zbathy(ji,jj,jobs))+1,jobs) > maxdepw ) THEN
+                     maxdepw = zgdepw(ji,jj,NINT(zbathy(ji,jj,jobs))+1,jobs)
+                  END IF
+               END DO
+            END DO
+
             ! Flag if the observation falls outside the model spatial domain
-            IF (       ( pobslam(jobs) < -180.         )       &
-               &  .OR. ( pobslam(jobs) >  180.         )       &
-               &  .OR. ( pobsphi(jobs) <  -90.         )       &
-               &  .OR. ( pobsphi(jobs) >   90.         )       &
-               &  .OR. ( pobsdep(jobsp) < 0.0          )       &
-               &  .OR. ( pobsdep(jobsp) > gdepw_1d(kpk)) ) THEN
+            IF (       ( pobslam(jobs) < -180.    )       &
+               &  .OR. ( pobslam(jobs) >  180.    )       &
+               &  .OR. ( pobsphi(jobs) <  -90.    )       &
+               &  .OR. ( pobsphi(jobs) >   90.    )       &
+               &  .OR. ( pobsdep(jobsp) < 0.0     )       &
+               &  .OR. ( pobsdep(jobsp) > gdepw_1d(kpk) ) ) THEN
                kobsqc(jobsp) = IBSET(kobsqc(jobsp),11)
                kosdobs = kosdobs + 1
@@ -1320,6 +1340,15 @@
             ! Set observation depth equal to that of the first model depth
             IF ( pobsdep(jobsp) <= pdep(1) ) THEN
-               pobsdep(jobsp) = pdep(1)  
-            ENDIF
+               pobsdep(jobsp) = pdep(1) 
+            ENDIF
+            !IF ( pobsdep(jobsp) < MINVAL(zgdept(1:2,1:2,1,jobs) ) ) THEN
+            !   pobsdep(jobsp) = MINVAL(zgdept(1:2,1:2,1,jobs))
+            !ENDIF
+
+            ! Set observation depth equal to that of the last wet T-point
+            !IF ( ( pobsdep(jobsp) > maxdept ) .AND. &
+            !   & ( pobsdep(jobsp) < maxdepw ) ) THEN
+            !   pobsdep(jobsp) = maxdept
+            !END IF
             
             IF (ln_bdy) THEN
@@ -1395,5 +1424,5 @@
 
 
-   SUBROUTINE obs_uv_rej( profdata, knumu, knumv, kqc_cutoff )
+   SUBROUTINE obs_uv_rej( profdata, knumu, knumv, kqc_cutoff, kuvar, kvvar )
       !!----------------------------------------------------------------------
       !!                    ***  ROUTINE obs_uv_rej ***
@@ -1412,5 +1441,7 @@
       INTEGER, INTENT(INOUT) :: knumu             ! Number of u rejected
       INTEGER, INTENT(INOUT) :: knumv             ! Number of v rejected
-      INTEGER, INTENT(IN) :: kqc_cutoff           ! QC cutoff value
+      INTEGER, INTENT(IN)    :: kqc_cutoff        ! QC cutoff value
+      INTEGER, INTENT(IN)    :: kuvar             ! Index of u
+      INTEGER, INTENT(IN)    :: kvvar             ! Index of v
       !
       INTEGER :: jprof
@@ -1421,6 +1452,6 @@
       DO jprof = 1, profdata%nprof      !==  Loop over profiles  ==!
          !
-         IF ( ( profdata%npvsta(jprof,1) /= profdata%npvsta(jprof,2) ) .OR. &
-            & ( profdata%npvend(jprof,1) /= profdata%npvend(jprof,2) ) ) THEN
+         IF ( ( profdata%npvsta(jprof,kuvar) /= profdata%npvsta(jprof,kvvar) ) .OR. &
+            & ( profdata%npvend(jprof,kuvar) /= profdata%npvend(jprof,kvvar) ) ) THEN
             !
             CALL ctl_stop('U,V profiles inconsistent in obs_uv_rej')
@@ -1429,14 +1460,14 @@
          ENDIF
          !
-         DO jobs = profdata%npvsta(jprof,1), profdata%npvend(jprof,1)
+         DO jobs = profdata%npvsta(jprof,kuvar), profdata%npvend(jprof,kuvar)
             !  
-            IF ( ( profdata%var(1)%nvqc(jobs) >  kqc_cutoff ) .AND. &
-               & ( profdata%var(2)%nvqc(jobs) <=  kqc_cutoff) ) THEN
-               profdata%var(2)%nvqc(jobs) = IBSET(profdata%var(1)%nvqc(jobs),15)
+            IF ( ( profdata%var(kuvar)%nvqc(jobs) >  kqc_cutoff ) .AND. &
+               & ( profdata%var(kvvar)%nvqc(jobs) <=  kqc_cutoff) ) THEN
+               profdata%var(kvvar)%nvqc(jobs) = IBSET(profdata%var(kuvar)%nvqc(jobs),15)
                knumv = knumv + 1
             ENDIF
-            IF ( ( profdata%var(2)%nvqc(jobs) >  kqc_cutoff ) .AND. &
-               & ( profdata%var(1)%nvqc(jobs) <=  kqc_cutoff) ) THEN
-               profdata%var(1)%nvqc(jobs) = IBSET(profdata%var(1)%nvqc(jobs),15)
+            IF ( ( profdata%var(kvvar)%nvqc(jobs) >  kqc_cutoff ) .AND. &
+               & ( profdata%var(kuvar)%nvqc(jobs) <=  kqc_cutoff) ) THEN
+               profdata%var(kuvar)%nvqc(jobs) = IBSET(profdata%var(kuvar)%nvqc(jobs),15)
                knumu = knumu + 1
             ENDIF
Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_profiles_def.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_profiles_def.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/obs_profiles_def.F90	(revision 15799)
@@ -43,8 +43,10 @@
       & obs_prof_alloc,     &
       & obs_prof_alloc_var, &
+      & obs_prof_alloc_ext, &
       & obs_prof_dealloc,   &
       & obs_prof_compress,  &
       & obs_prof_decompress,&
-      & obs_prof_staend
+      & obs_prof_staend,    &
+      & obs_prof_staend_ext
 
    !! * Type definition for valid observations
@@ -75,5 +77,5 @@
 
       REAL(KIND=wp), POINTER, DIMENSION(:,:) :: &
-         & vext           !: Extra variables
+         & vadd           !: Additional variables
 
       INTEGER, POINTER, DIMENSION(:) :: &
@@ -87,4 +89,22 @@
    END TYPE obs_prof_var
 
+   !! * Type definition for extra variables
+
+   TYPE obs_prof_ext
+
+      ! Arrays with size equal to the number of observations
+
+      INTEGER, POINTER, DIMENSION(:) :: &
+         & nepidx,&       !: Profile number
+         & nelidx         !: Level number in profile
+
+      REAL(KIND=wp), POINTER, DIMENSION(:,:) :: &
+         & eobs           !: Profile data
+
+      INTEGER, POINTER, DIMENSION(:) :: &
+         & neind          !: Source indices of temp. data in compressed data
+
+   END TYPE obs_prof_ext
+
    !! * Type definition for profile observation type
 
@@ -94,5 +114,6 @@
 
       INTEGER :: nvar     !: Number of variables
-      INTEGER :: next     !: Number of extra fields
+      INTEGER :: next     !: Number of extra variables
+      INTEGER :: nadd     !: Number of additional variables
       INTEGER :: nprof    !: Total number of profiles within window.
       INTEGER :: nstp     !: Number of time steps
@@ -104,10 +125,29 @@
       ! Bookkeeping arrays with sizes equal to number of variables
 
-      CHARACTER(len=8), POINTER, DIMENSION(:) :: &
-         & cvars          !: Variable names
+      CHARACTER(len=ilenname), POINTER, DIMENSION(:) :: &
+         & cvars,    &    !: Variable names
+         & cextvars, &    !: Extra variable names
+         & caddvars       !: Additional variable names
+
+      CHARACTER(len=ilenlong), POINTER, DIMENSION(:) :: &
+         & clong,    &    !: Variable long names
+         & cextlong       !: Extra variable long names
+
+      CHARACTER(len=ilenlong), POINTER, DIMENSION(:,:) :: &
+         & caddlong       !: Additional variable long names
+
+      CHARACTER(len=ilenunit), POINTER, DIMENSION(:) :: &
+         & cunit,    &    !: Variable units
+         & cextunit       !: Extra variable units
+
+      CHARACTER(len=ilenunit), POINTER, DIMENSION(:,:) :: &
+         & caddunit       !: Additional variable units
+
+      CHARACTER(len=ilengrid), POINTER, DIMENSION(:) :: &
+         & cgrid          !: Variable grids
 
       INTEGER, POINTER, DIMENSION(:) :: &
-         & nvprot,   &    !: Local total number of profile T data
-         & nvprotmpp      !: Global total number of profile T data
+         & nvprot,   &    !: Local total number of profile data
+         & nvprotmpp      !: Global total number of profile data
       
       ! Arrays with size equal to the number of profiles
@@ -131,5 +171,5 @@
          & rphi           !: Latitude coordinate of profile data
 
-      CHARACTER(LEN=8), POINTER, DIMENSION(:) :: &
+      CHARACTER(LEN=ilenwmo), POINTER, DIMENSION(:) :: &
          & cwmo           !: Profile WMO indentifier
       
@@ -140,6 +180,6 @@
          & npvsta, &      !: Start of each variable profile in full arrays
          & npvend, &      !: End of each variable profile in full arrays
-         & mi,     &      !: i-th grid coord. for interpolating to profile T data
-         & mj,     &      !: j-th grid coord. for interpolating to profile T data
+         & mi,     &      !: i-th grid coord. for interpolating to profile data
+         & mj,     &      !: j-th grid coord. for interpolating to profile data
          & ivqc           !: QC flags for all levels for a variable
 
@@ -160,4 +200,14 @@
       TYPE(obs_prof_var), POINTER, DIMENSION(:) :: var
 
+      ! Extra variables
+
+      TYPE(obs_prof_ext) :: vext
+
+      INTEGER :: nvprotext  !: Local total number of extra variable profile data
+
+      INTEGER, POINTER, DIMENSION(:) :: &
+         & npvstaext, &      !: Start of extra variable profiles in full arrays
+         & npvendext         !: End of extra variable profiles in full arrays
+
       ! Arrays with size equal to the number of time steps in the window
 
@@ -197,6 +247,6 @@
 CONTAINS
    
-   SUBROUTINE obs_prof_alloc( prof,  kvar, kext, kprof,  &
-      &                       ko3dt, kstp, kpi, kpj, kpk )
+   SUBROUTINE obs_prof_alloc( prof,  kvar, kadd, kext, kprof,  &
+      &                       ko3dt, ke3dt, kstp, kpi, kpj, kpk )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE obs_prof_alloc  ***
@@ -214,7 +264,9 @@
       INTEGER, INTENT(IN) :: kprof  ! Number of profiles
       INTEGER, INTENT(IN) :: kvar   ! Number of variables
-      INTEGER, INTENT(IN) :: kext   ! Number of extra fields within each variable
+      INTEGER, INTENT(IN) :: kadd   ! Number of additional fields within each variable
+      INTEGER, INTENT(IN) :: kext   ! Number of extra fields
       INTEGER, INTENT(IN), DIMENSION(kvar) :: &
          & ko3dt     ! Number of observations per variables
+      INTEGER, INTENT(IN) :: ke3dt  ! Number of observations per extra variables
       INTEGER, INTENT(IN) :: kstp   ! Number of time steps
       INTEGER, INTENT(IN) :: kpi    ! Number of 3D grid points
@@ -223,5 +275,5 @@
 
       !!* Local variables
-      INTEGER :: jvar
+      INTEGER :: jvar, jadd, jext
       INTEGER :: ji
 
@@ -229,4 +281,5 @@
 
       prof%nvar      = kvar
+      prof%nadd      = kadd
       prof%next      = kext
       prof%nprof     = kprof
@@ -241,4 +294,7 @@
       ALLOCATE( &
          & prof%cvars(kvar),    &
+         & prof%clong(kvar),    &
+         & prof%cunit(kvar),    &
+         & prof%cgrid(kvar),    &
          & prof%nvprot(kvar),   &
          & prof%nvprotmpp(kvar) &
@@ -247,6 +303,34 @@
       DO jvar = 1, kvar
          prof%cvars    (jvar) = "NotSet"
+         prof%clong    (jvar) = "NotSet"
+         prof%cunit    (jvar) = "NotSet"
+         prof%cgrid    (jvar) = ""
          prof%nvprot   (jvar) = ko3dt(jvar)
          prof%nvprotmpp(jvar) = 0
+      END DO
+
+      ! Allocate additional/extra variable metadata
+
+      ALLOCATE( &
+         & prof%caddvars(kadd),      &
+         & prof%caddlong(kadd,kvar), &
+         & prof%caddunit(kadd,kvar), &
+         & prof%cextvars(kext),      &
+         & prof%cextlong(kext),      &
+         & prof%cextunit(kext)       &
+         )
+         
+      DO jadd = 1, kadd
+         prof%caddvars(jadd) = "NotSet"
+         DO jvar = 1, kvar
+            prof%caddlong(jadd,jvar) = "NotSet"
+            prof%caddunit(jadd,jvar) = "NotSet"
+         END DO
+      END DO
+         
+      DO jext = 1, kext
+         prof%cextvars(jext) = "NotSet"
+         prof%cextlong(jext) = "NotSet"
+         prof%cextunit(jext) = "NotSet"
       END DO
 
@@ -306,10 +390,20 @@
 
       DO jvar = 1, kvar
-
          IF ( ko3dt(jvar) >= 0 ) THEN
-            CALL obs_prof_alloc_var( prof, jvar, kext, ko3dt(jvar) )
+            CALL obs_prof_alloc_var( prof, jvar, kadd, ko3dt(jvar) )
          ENDIF
-         
-      END DO
+      END DO
+      
+      ! Extra variables
+
+      IF ( kext > 0 ) THEN
+         prof%nvprotext = ke3dt
+         ALLOCATE( &
+            & prof%npvstaext(kprof), &  
+            & prof%npvendext(kprof) )
+         CALL obs_prof_alloc_ext( prof, kext, ke3dt )
+      ELSE
+         prof%nvprotext = 0
+      ENDIF
 
       ! Allocate arrays of size number of time step size
@@ -346,4 +440,10 @@
          END DO
       END DO
+
+      IF ( kext > 0 ) THEN
+         DO ji = 1, ke3dt
+            prof%vext%neind(ji) = ji
+         END DO
+      ENDIF
 
       ! Set defaults for number of observations per time step
@@ -377,5 +477,6 @@
       !!* Local variables
       INTEGER :: &
-         & jvar
+         & jvar, &
+         & jext
 
       ! Deallocate arrays of size number of profiles
@@ -418,11 +519,7 @@
 
       DO jvar = 1, prof%nvar
-
          IF ( prof%nvprot(jvar) >= 0 ) THEN
-
             CALL obs_prof_dealloc_var( prof, jvar )
-
          ENDIF
-         
       END DO
 
@@ -432,4 +529,13 @@
          & )
 
+      ! Deallocate extra variables
+      IF ( prof%next > 0 ) THEN
+         DEALLOCATE( &
+            & prof%npvstaext, &  
+            & prof%npvendext  &
+            )
+         CALL obs_prof_dealloc_ext( prof )
+      ENDIF
+      
       ! Deallocate arrays of size number of time step size
 
@@ -458,13 +564,26 @@
       DEALLOCATE( &
          & prof%cvars,    &
+         & prof%clong,    &
+         & prof%cunit,    &
+         & prof%cgrid,    &
          & prof%nvprot,   &
          & prof%nvprotmpp &
          )
 
+      ! Dellocate additional/extra variables metadata
+
+      DEALLOCATE( &
+         & prof%caddvars, &
+         & prof%caddlong, &
+         & prof%caddunit, &
+         & prof%cextvars, &
+         & prof%cextlong, &
+         & prof%cextunit  &
+         )
 
    END SUBROUTINE obs_prof_dealloc
 
 
-   SUBROUTINE obs_prof_alloc_var( prof, kvar, kext, kobs )
+   SUBROUTINE obs_prof_alloc_var( prof, kvar, kadd, kobs )
 
       !!----------------------------------------------------------------------
@@ -480,5 +599,5 @@
       TYPE(obs_prof), INTENT(INOUT) :: prof   ! Profile data to be allocated
       INTEGER, INTENT(IN) :: kvar   ! Variable number
-      INTEGER, INTENT(IN) :: kext   ! Number of extra fields within each variable
+      INTEGER, INTENT(IN) :: kadd   ! Number of additional fields within each variable
       INTEGER, INTENT(IN) :: kobs   ! Number of observations
       
@@ -498,7 +617,7 @@
          & prof%var(kvar)%nvqcf(idefnqcf,kobs)  &
          & )
-      IF (kext>0) THEN
+      IF (kadd>0) THEN
          ALLOCATE( & 
-            & prof%var(kvar)%vext(kobs,kext) &
+            & prof%var(kvar)%vadd(kobs,kadd) &
             & )
       ENDIF
@@ -506,10 +625,11 @@
    END SUBROUTINE obs_prof_alloc_var
 
+
    SUBROUTINE obs_prof_dealloc_var( prof, kvar )
 
       !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE obs_prof_alloc_var  ***
+      !!                     ***  ROUTINE obs_prof_dealloc_var  ***
       !!                      
-      !! ** Purpose : - Allocate data for variable data in profile arrays
+      !! ** Purpose : - Deallocate data for variable data in profile arrays
       !! 
       !! ** Method  : - Fortran-90 dynamic arrays
@@ -518,5 +638,5 @@
       !!        !  07-03  (K. Mogensen) Original code
       !! * Arguments
-      TYPE(obs_prof), INTENT(INOUT) :: prof   ! Profile data to be allocated
+      TYPE(obs_prof), INTENT(INOUT) :: prof   ! Profile data to be deallocated
       INTEGER, INTENT(IN) :: kvar      ! Variable number
       
@@ -534,7 +654,7 @@
          & prof%var(kvar)%nvqcf   &
          & )
-      IF (prof%next>0) THEN
+      IF (prof%nadd>0) THEN
          DEALLOCATE( & 
-            & prof%var(kvar)%vext  &
+            & prof%var(kvar)%vadd  &
             & )
       ENDIF
@@ -542,6 +662,57 @@
    END SUBROUTINE obs_prof_dealloc_var
 
+
+   SUBROUTINE obs_prof_alloc_ext( prof, kext, kobs )
+
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE obs_prof_alloc_ext  ***
+      !!                      
+      !! ** Purpose : - Allocate data for extra variables in profile arrays
+      !! 
+      !! ** Method  : - Fortran-90 dynamic arrays
+      !!
+      !! History :
+      !!        !  07-03  (K. Mogensen) Original code
+      !! * Arguments
+      TYPE(obs_prof), INTENT(INOUT) :: prof   ! Profile data to be allocated
+      INTEGER,        INTENT(IN)    :: kext   ! Number of extra variables
+      INTEGER,        INTENT(IN)    :: kobs   ! Number of observations
+
+      ALLOCATE( &
+         & prof%vext%nepidx(kobs),   &
+         & prof%vext%nelidx(kobs),   &
+         & prof%vext%neind(kobs),    &
+         & prof%vext%eobs(kobs,kext) &
+         & )
+
+   END SUBROUTINE obs_prof_alloc_ext
+
+
+   SUBROUTINE obs_prof_dealloc_ext( prof )
+
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE obs_prof_dealloc_var  ***
+      !!                      
+      !! ** Purpose : - Deallocate data for extra variables in profile arrays
+      !! 
+      !! ** Method  : - Fortran-90 dynamic arrays
+      !!
+      !! History :
+      !!        !  07-03  (K. Mogensen) Original code
+      !! * Arguments
+      TYPE(obs_prof), INTENT(INOUT) :: prof   ! Profile data to be deallocated
+      
+      DEALLOCATE( &
+         & prof%vext%nepidx, &
+         & prof%vext%nelidx, &
+         & prof%vext%eobs,   &
+         & prof%vext%neind   &
+         & )
+
+   END SUBROUTINE obs_prof_dealloc_ext
+
+
    SUBROUTINE obs_prof_compress( prof,   newprof, lallocate, &
-      &                          kumout, lvalid,   lvvalid )
+      &                          kumout, lvalid,  lvvalid )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE obs_prof_compress  ***
@@ -564,6 +735,6 @@
       TYPE(obs_prof), INTENT(IN)    :: prof      ! Original profile
       TYPE(obs_prof), INTENT(INOUT) :: newprof   ! New profile with the copy of the data
-      LOGICAL :: lallocate                ! Allocate newprof data
-      INTEGER,INTENT(IN) :: kumout        ! Fortran unit for messages
+      LOGICAL,        INTENT(IN)    :: lallocate ! Allocate newprof data
+      INTEGER,        INTENT(IN)    :: kumout    ! Fortran unit for messages
       TYPE(obs_prof_valid), OPTIONAL, INTENT(in) :: &
          & lvalid        ! Valid profiles
@@ -575,5 +746,7 @@
       INTEGER, DIMENSION(prof%nvar) :: &
          & invpro
+      INTEGER :: invproext
       INTEGER :: jvar
+      INTEGER :: jadd
       INTEGER :: jext
       INTEGER :: ji
@@ -587,5 +760,5 @@
       LOGICAL :: lnonepresent
 
-      ! Check that either all or none of the masks are persent.
+      ! Check that either all or none of the masks are present.
 
       lallpresent  = .FALSE.
@@ -607,7 +780,8 @@
          inprof = 0
          invpro(:) = 0
+         invproext = 0
          DO ji = 1, prof%nprof
             IF ( lvalid%luse(ji) ) THEN
-               inprof=inprof+1
+               inprof = inprof + 1
                DO jvar = 1, prof%nvar
                   DO jj = prof%npvsta(ji,jvar), prof%npvend(ji,jvar)
@@ -616,4 +790,9 @@
                   END DO
                END DO
+               IF ( prof%next > 0 ) THEN
+                  DO jj = prof%npvstaext(ji), prof%npvendext(ji)
+                     invproext = invproext + 1
+                  END DO
+               ENDIF
             ENDIF
          END DO
@@ -621,4 +800,5 @@
          inprof    = prof%nprof
          invpro(:) = prof%nvprot(:)
+         invproext = prof%nvprotext
       ENDIF
 
@@ -627,6 +807,7 @@
       IF ( lallocate ) THEN
          CALL obs_prof_alloc( newprof,   prof%nvar, &
-            &                 prof%next,            &
+            &                 prof%nadd, prof%next, &
             &                 inprof,    invpro,    &
+            &                 invproext,            &
             &                 prof%nstp, prof%npi,  &
             &                 prof%npj,  prof%npk )
@@ -655,7 +836,10 @@
       inprof    = 0
       invpro(:) = 0
-
-      newprof%npvsta(:,:) =  0
-      newprof%npvend(:,:) = -1
+      invproext = 0
+
+      newprof%npvsta(:,:)  =  0
+      newprof%npvend(:,:)  = -1
+      newprof%npvstaext(:) =  0
+      newprof%npvendext(:) = -1
       
       ! Loop over source profiles
@@ -670,5 +854,5 @@
 
             newprof%mi(inprof,:)  = prof%mi(ji,:)
-            newprof%mj(inprof,:) = prof%mj(ji,:)
+            newprof%mj(inprof,:)  = prof%mj(ji,:)
             newprof%npidx(inprof) = prof%npidx(ji)
             newprof%npfil(inprof) = prof%npfil(ji)
@@ -741,7 +925,7 @@
                      newprof%var(jvar)%vmod(invpro(jvar))   = &
                         &                           prof%var(jvar)%vmod(jj)
-                     DO jext = 1, prof%next
-                        newprof%var(jvar)%vext(invpro(jvar),jext) = &
-                           &                      prof%var(jvar)%vext(jj,jext)
+                     DO jadd = 1, prof%nadd
+                        newprof%var(jvar)%vadd(invpro(jvar),jadd) = &
+                           &                      prof%var(jvar)%vadd(jj,jadd)
                      END DO
                   
@@ -756,4 +940,38 @@
             END DO
 
+            IF ( prof%next > 0 ) THEN
+
+               ! Extra variables
+
+               lfirst = .TRUE.
+
+               DO jj = prof%npvstaext(ji), prof%npvendext(ji)
+
+                  invproext = invproext + 1
+
+                  ! Book keeping information
+
+                  IF ( lfirst ) THEN
+                     lfirst = .FALSE.
+                     newprof%npvstaext(inprof) = invproext
+                  ENDIF
+                  newprof%npvendext(inprof) = invproext
+
+                  ! Variable data
+
+                  newprof%vext%nepidx(invproext) = prof%vext%nepidx(jj)
+                  newprof%vext%nelidx(invproext) = prof%vext%nelidx(jj)
+                  DO jext = 1, prof%next
+                     newprof%vext%eobs(invproext,jext) = prof%vext%eobs(jj,jext)
+                  END DO
+
+                  ! nvind is the index of the original variable data
+
+                  newprof%vext%neind(invproext)  = jj
+
+               END DO
+
+            ENDIF
+
          ENDIF
 
@@ -767,8 +985,10 @@
       CALL obs_mpp_sum_integers ( newprof%nvprot, newprof%nvprotmpp,&
          &                        prof%nvar )
+      newprof%nvprotext = invproext
       
       ! Set book keeping variables which do not depend on number of obs.
 
       newprof%nvar     = prof%nvar
+      newprof%nadd     = prof%nadd
       newprof%next     = prof%next
       newprof%nstp     = prof%nstp
@@ -777,4 +997,13 @@
       newprof%npk      = prof%npk
       newprof%cvars(:) = prof%cvars(:)
+      newprof%clong(:) = prof%clong(:)
+      newprof%cunit(:) = prof%cunit(:)
+      newprof%cgrid(:) = prof%cgrid(:)
+      newprof%caddvars(:)   = prof%caddvars(:)
+      newprof%caddlong(:,:) = prof%caddlong(:,:)
+      newprof%caddunit(:,:) = prof%caddunit(:,:)
+      newprof%cextvars(:)   = prof%cextvars(:)
+      newprof%cextlong(:)   = prof%cextlong(:)
+      newprof%cextunit(:)   = prof%cextunit(:)
  
       ! Deallocate temporary data
@@ -810,4 +1039,5 @@
       !!* Local variables
       INTEGER :: jvar
+      INTEGER :: jadd
       INTEGER :: jext
       INTEGER :: ji
@@ -866,7 +1096,7 @@
                oldprof%var(jvar)%idqcf(:,jl) = prof%var(jvar)%idqcf(:,jj)
                oldprof%var(jvar)%nvqcf(:,jl) = prof%var(jvar)%nvqcf(:,jj)
-               DO jext = 1, prof%next
-                  oldprof%var(jvar)%vext(jl,jext) = &
-                     &                        prof%var(jvar)%vext(jj,jext)
+               DO jadd = 1, prof%nadd
+                  oldprof%var(jvar)%vadd(jl,jadd) = &
+                     &                        prof%var(jvar)%vadd(jj,jadd)
                END DO
                
@@ -874,4 +1104,20 @@
 
          END DO
+
+         IF ( prof%next > 0 ) THEN
+
+            DO jj = prof%npvstaext(ji), prof%npvendext(ji)
+
+               jl = prof%vext%neind(jj)
+
+               oldprof%vext%nepidx(jl) = prof%vext%nepidx(jj)
+               oldprof%vext%nelidx(jl) = prof%vext%nelidx(jj)
+               DO jext = 1, prof%next
+                  oldprof%vext%eobs(jl,jext) = prof%vext%eobs(jj,jext)
+               END DO
+
+            END DO
+
+         ENDIF
          
       END DO
@@ -883,7 +1129,8 @@
    END SUBROUTINE obs_prof_decompress
 
+
    SUBROUTINE obs_prof_staend( prof, kvarno )
       !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE obs_prof_decompress  ***
+      !!                     ***  ROUTINE obs_prof_staend  ***
       !!                      
       !! ** Purpose : - Set npvsta and npvend of a variable within 
@@ -924,4 +1171,46 @@
 
    END SUBROUTINE obs_prof_staend
+
+
+   SUBROUTINE obs_prof_staend_ext( prof )
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE obs_prof_staend_ext  ***
+      !!                      
+      !! ** Purpose : - Set npvsta and npvend within 
+      !!                an obs_prof_ext type
+      !!
+      !! ** Method  : - Find the start and stop of a profile by searching 
+      !!                through the data
+      !! 
+      !! History :
+      !!        !  07-04  (K. Mogensen) Original code
+      !!----------------------------------------------------------------------
+      !! * Arguments
+      TYPE(obs_prof),INTENT(INOUT) :: prof     ! Profile data
+
+      !!* Local variables
+      INTEGER :: ji
+      INTEGER :: iprofno
+
+      !-----------------------------------------------------------------------
+      ! Compute start and end bookkeeping arrays
+      !-----------------------------------------------------------------------
+
+      prof%npvstaext(:) = prof%nvprotext + 1
+      prof%npvendext(:) = -1
+      DO ji = 1, prof%nvprotext
+         iprofno = prof%vext%nepidx(ji)
+         prof%npvstaext(iprofno) = &
+            & MIN( ji, prof%npvstaext(iprofno) )
+         prof%npvendext(iprofno) = &
+            & MAX( ji, prof%npvendext(iprofno) )
+      END DO
+
+      DO ji = 1, prof%nprof
+         IF ( prof%npvstaext(ji) == ( prof%nvprotext + 1 ) ) &
+            & prof%npvstaext(ji) = 0
+      END DO
+
+   END SUBROUTINE obs_prof_staend_ext
    
 END MODULE obs_profiles_def
